/* 2darray.c -- 2dimensional array functions
 *
 * SEE 2darray.h for details
 */

#include <stdlib.h>
#include "2darray.h"

bool Allocate2DArray(char ***array, int xSize, int ySize, size_t elementSize)
{
	int     index;

	if (!((*array) = (char **) malloc(ySize * sizeof(void *))))  
		return FALSE;

	for (index = 0; index < ySize; index++) {
		if (!((*array)[index] = (char *) malloc(xSize * elementSize))) {
			free(*array);
			return FALSE;
		}
	}

	return TRUE;
}

void Deallocate2DArray(char ***array, int ySize)
{
	int	index;

	for (index = 0; index < ySize; index++)
		free((*array)[index]);

	free(*array);
	(*array) = NULL;
}

/* --- END of 2darray.c --- */

