#include <math.h>
#define NRANSI
#include "nrutil.h"
#define SWAP(a,b) {temp=(a);(a)=(b);(b)=temp;}

void GaussInverse(double **a, int n)
{
	int *indxc,*indxr,*ipiv;
	int i,icol,irow,j,k,l,ll;
	double big,dum,pivinv,temp;

	indxc=ivector(1,n);
	indxr=ivector(1,n);
	ipiv=ivector(1,n);
	for (j=1;j<=n;j++) ipiv[j]=0;
	for (i=1;i<=n;i++) {
		big=0.0;
		for (j=1;j<=n;j++)
			if (ipiv[j] != 1)
				for (k=1;k<=n;k++) {
					if (ipiv[k] == 0) {
						if (fabs(a[j-1][k-1]) >= big) {
							big=fabs(a[j-1][k-1]);
							irow=j;
							icol=k;
						}
					} else if (ipiv[k] > 1) nrerror("gaussj: Singular Matrix-1");
				}
		++(ipiv[icol]);
		if (irow != icol) {
			for (l=1;l<=n;l++) SWAP(a[irow-1][l-1],a[icol-1][l-1])
/*			for (l=1;l<=m;l++) SWAP(b[irow][l],b[icol][l]) */
		}
		indxr[i]=irow;
		indxc[i]=icol;
		if (a[icol-1][icol-1] == 0.0) nrerror("gaussj: Singular Matrix-2");
		pivinv=1.0/a[icol-1][icol-1];
		a[icol-1][icol-1]=1.0;
		for (l=1;l<=n;l++) a[icol-1][l-1] *= pivinv;
/*		for (l=1;l<=m;l++) b[icol-1][l-1] *= pivinv; */
		for (ll=1;ll<=n;ll++)
			if (ll != icol) {
				dum=a[ll-1][icol-1];
				a[ll-1][icol-1]=0.0;
				for (l=1;l<=n;l++) a[ll-1][l-1] -= a[icol-1][l-1]*dum;
/*				for (l=1;l<=m;l++) b[ll-1][l-1] -= b[icol][l]*dum;*/
			}
	}
	for (l=n;l>=1;l--) {
		if (indxr[l] != indxc[l])
			for (k=1;k<=n;k++)
				SWAP(a[k-1][indxr[l]-1],a[k-1][indxc[l]-1]);
	}
	free_ivector(ipiv,1,n);
	free_ivector(indxr,1,n);
	free_ivector(indxc,1,n);
}
#undef SWAP
#undef NRANSI
/* (C) Copr. 1986-92 Numerical Recipes Software ***. */
